## liblas 1.8.1

=== CMakeLists.txt ===
###############################################################################
# Main CMake configuration file for libLAS
#
# Author: Mateusz Loskot <mateusz@loskot.net>
#
#
###############################################################################
# libLAS general settings
project(libLAS)


SET(LIBLAS_VERSION_MAJOR "1")
SET(LIBLAS_VERSION_MINOR "8")
SET(LIBLAS_VERSION_PATCH "1")
set(VERSION "${LIBLAS_VERSION_MAJOR}.${LIBLAS_VERSION_MINOR}.${LIBLAS_VERSION_PATCH}")
SET(LIBLAS_LIB_VERSION "2.4.0")
SET(LIBLAS_LIB_SOVERSION "3")
SET(LIBLAS_C_LIB_VERSION "2.4.0")
SET(LIBLAS_C_LIB_SOVERSION "3")
SET(OSGEO4W_UPSTREAM_RELEASE "1")

if(WIN32)
  # Name of C++ library
  set(LIBLAS_LIB_NAME liblas)

  # Name of C library
  set(LIBLAS_C_LIB_NAME liblas_c)

  # Name of Chipper library
  set(LASCHIP_LIB_NAME liblas_chipper )

  # Name of Kernel libray
  set(LASKERNEL_LIB_NAME liblas_kernel )

else()
  # Name of C++ library
  set(LIBLAS_LIB_NAME las)

  # Name of C library
  set(LIBLAS_C_LIB_NAME las_c)

  # Name of Chipper library
  set(LASCHIP_LIB_NAME las_chipper )

  # Name of Kernel libray
  set(LASKERNEL_LIB_NAME las_kernel )
endif()

# Name of test suite runner
set(LIBLAS_UNIT_TEST liblas_test)

set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

# Choose package components
set(WITH_UTILITIES TRUE CACHE BOOL "Choose if libLAS utilities should be built")
set(WITH_TESTS TRUE CACHE BOOL "Choose if libLAS unit tests should be built")
set(BUILD_OSGEO4W TRUE CACHE BOOL "Should OSGeo4W package for Windows be built")

# Choose to use pkg-config or not
set(WITH_PKGCONFIG FALSE CACHE BOOL
  "Choose whether a pkgconfig file (libLAS.pc) should be installed")

set(WITH_ENDIANAWARE FALSE CACHE BOOL "Choose whether or not libLAS should do runtime endianness switching.  Note that this can slow things down considerably if enabled by default")

###############################################################################
# CMake settings
cmake_minimum_required(VERSION 2.6.0)

set(CMAKE_COLOR_MAKEFILE ON)

# Allow advanced users to generate Makefiles printing detailed commands
mark_as_advanced(CMAKE_VERBOSE_MAKEFILE)

# Path to additional CMake modules
set(CMAKE_MODULE_PATH "${libLAS_SOURCE_DIR}/cmake/modules" ${CMAKE_MODULE_PATH})
if (CMAKE_MAJOR_VERSION GREATER 2)
    cmake_policy(SET CMP0042 OLD)
endif()

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
set(CMAKE_SKIP_RPATH ON)
endif()

###############################################################################
# General build settings

# Default to debug mode until final 1.6.0 release
if(NOT MSVC_IDE)
  if(NOT CMAKE_BUILD_TYPE)

  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel" FORCE)
  endif()
    message(STATUS "Setting libLAS build type - ${CMAKE_BUILD_TYPE}")
endif()

# TODO: Still testing the output paths --mloskot
set(LIBLAS_BUILD_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin/${CMAKE_BUILD_TYPE}")

# Output directory in which to build RUNTIME target files.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${LIBLAS_BUILD_OUTPUT_DIRECTORY})

# Output directory in which to build LIBRARY target files
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${LIBLAS_BUILD_OUTPUT_DIRECTORY})

# Output directory in which to build ARCHIVE target files.
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${LIBLAS_BUILD_OUTPUT_DIRECTORY})

file(READ "doc/index.txt" README )
file(WRITE "README.txt" "${README}")

###############################################################################
# Platform and compiler specific settings

if(WIN32)
  if (MSVC)
    if (MSVC80 OR MSVC90 OR MSVC10 OR MSVC11 OR MSVC12)
      add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
      add_definitions(-D_CRT_SECURE_NO_WARNINGS)
      add_definitions(-D_CRT_NONSTDC_NO_WARNING)
      add_definitions(-D_SCL_SECURE_NO_WARNINGS)
    endif()

    if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
      string(REGEX REPLACE "/W[0-4]" "/W4"
        CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
    endif()

    # Generate dot-user file with user-specific settings for
    # Visual Studio project
    set(MSVC_ENVIRONMENT_PATH "" CACHE STRING
      "Custom PATH for Environment property in Visual Studio for project")
    mark_as_advanced(MSVC_ENVIRONMENT_PATH)
    set(VCPROJ_USER_ENVIRONMENT_PATH_DEBUG "${ENVIRONMENT_PATH}")
    mark_as_advanced(VCPROJ_USER_ENVIRONMENT_PATH_DEBUG)

  endif()

  set(CMAKE_INCLUDE_PATH c:/osgeo4w64/include;$ENV{CMAKE_INCLUDE_PATH})
  set(CMAKE_LIBRARY_PATH c:/osgeo4w64/lib;$ENV{CMAKE_LIBRARY_PATH})
else()

  # Recommended C++ compilation flags
  # -Weffc++
  #
  # Remove -pedandic which causes errors from boost (comma at end of
  # enum) 2012-09-05.  Remove -Wcast-qual -Wfloat-equal
  # -Wredundant-decls to suppress the multitude of warning messages.
  set(LIBLAS_COMMON_CXX_FLAGS
	" -Wextra -Wall -Wno-unused-parameter -Wno-unused-variable -Wpointer-arith -Wcast-align -Wcast-qual -Wfloat-equal -Wredundant-decls -Wno-long-long")

  if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${LIBLAS_COMMON_CXX_FLAGS}")
    if (CMAKE_COMPILER_IS_GNUCXX)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98 -ansi")
    endif()

  elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang" OR "${CMAKE_CXX_COMPILER}" MATCHES "clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${LIBLAS_COMMON_CXX_FLAGS}")
  endif()
endif(WIN32)

if (APPLE)
  set(SO_EXT dylib)
  set(CMAKE_FIND_FRAMEWORK "LAST")
elseif(WIN32)
  set(SO_EXT dll)
else()
  set(SO_EXT so)
endif(APPLE)

###############################################################################
# Search for dependencies

# Boost C++ Libraries support - required
message(STATUS "Searching for Boost 1.38+ - done")

# Default to using static, multithreaded libraries for
# linking under MSVC.  This is because we show users how to
# use boostpro.com installer and install those options when linking
# on windows in the compilation documentation.
if(WIN32)
  if (MSVC)
    set(Boost_USE_STATIC_LIBS   ON)
    set(Boost_USE_MULTITHREADED ON)
  endif(MSVC)
endif(WIN32)

find_package(Threads)
find_package(Boost 1.42 COMPONENTS program_options thread system iostreams filesystem REQUIRED)

if(Boost_FOUND AND Boost_PROGRAM_OPTIONS_FOUND)
  include_directories(${Boost_INCLUDE_DIRS})
endif()

# make these available for the user to set.
mark_as_advanced(CLEAR Boost_INCLUDE_DIR)
mark_as_advanced(CLEAR Boost_LIBRARY_DIRS)
link_directories(${Boost_LIBRARY_DIRS})

# LASZIP support - optional, default=ON
set(WITH_LASZIP FALSE CACHE BOOL "Choose if LASzip support should be built")
set(WITH_STATIC_LASZIP FALSE CACHE BOOL "Choose of LASzip should be statically linked")
mark_as_advanced(WITH_STATIC_LASZIP)

if (WITH_LASZIP)
  find_package (LASzip 2.0.1 QUIET NO_MODULE)
  if (NOT LASZIP_FOUND)
    find_package (LASzip 2.0.1)
  endif ()
endif ()
if(LASZIP_FOUND)
    include_directories(${LASZIP_INCLUDE_DIR})
    add_definitions(-DHAVE_LASZIP=1)
    mark_as_advanced(CLEAR LASZIP_INCLUDE_DIR)
    mark_as_advanced(CLEAR LASZIP_LIBRARY)
    mark_as_advanced(CLEAR LASZIP_VERSION)
    set(WITH_LASZIP TRUE)
else()
    set(LASZIP_LIBRARY "")
    set(LASZIP_INCLUDE_DIR "")
endif()

# GDAL/OGR support - optional, default=OFF
set(WITH_GDAL FALSE CACHE BOOL "Choose if GDAL support should be built")

if (WITH_GDAL)
  find_package (GDAL 1.7.0 NO_MODULE QUIET)
  if (NOT GDAL_FOUND)
    find_package (GDAL 1.7.0)
  endif ()
endif ()
if (GDAL_FOUND)
  include_directories(${GDAL_INCLUDE_DIR})
  add_definitions(-DHAVE_GDAL=1)
  set(WITH_GDAL TRUE)
  mark_as_advanced(CLEAR GDAL_INCLUDE_DIR)
  mark_as_advanced(CLEAR GDAL_LIBRARY)
  find_package (PROJ4 NO_MODULE QUIET)
  if (NOT PROJ4_FOUND)
    find_package (PROJ4)
  endif ()
endif()

# GeoTIFF support - required, default=ON
set(WITH_GEOTIFF TRUE CACHE BOOL "Choose if GeoTIFF support should be built")

find_package (GeoTIFF 1.3.0 )
if(GEOTIFF_FOUND)
    set(WITH_GEOTIFF TRUE)
    # Confirm required API is available
    include(CheckFunctionExists)
    include_directories(${GEOTIFF_INCLUDE_DIR})
    add_definitions(-DHAVE_LIBGEOTIFF=1)

    mark_as_advanced(CLEAR TIFF_INCLUDE_DIR)
    mark_as_advanced(CLEAR TIFF_LIBRARY)
    if (WIN32)
        set(TIFF_NAMES libtiff_i)
    endif(WIN32)
    find_package (TIFF QUIET NO_MODULE)
    if (NOT TIFF_FOUND)
      find_package(TIFF)
    endif ()
    if (TIFF_FOUND)
      include_directories(${TIFF_INCLUDE_DIR})
    endif()
  find_package (JPEG NO_MODULE QUIET)
  if (NOT JPEG_FOUND)
    find_package (JPEG)
  endif ()
  find_package (ZLIB NO_MODULE QUIET)
  if (NOT ZLIB_FOUND)
    find_package (ZLIB)
  endif ()
else()
    message(FATAL_ERROR "Unable to find sufficient GeoTIFF")
endif()


if(WITH_GDAL)
  if (NOT GEOTIFF_FOUND)
    message(FATAL_ERROR
      "GDAL support requires GeoTIFF library which was not found")
  endif()
endif()


if(WITH_ENDIANAWARE)
    add_definitions(-DLIBLAS_ENDIAN_AWARE=1)
endif()
###############################################################################
# Installation settings

if(WIN32)
  set(DEFAULT_LIB_SUBDIR lib)
  set(DEFAULT_DATA_SUBDIR .)
  set(DEFAULT_INCLUDE_SUBDIR include)

  if (MSVC)
    set(DEFAULT_BIN_SUBDIR bin)
  else()
    set(DEFAULT_BIN_SUBDIR .)
  endif()
else()
  # Common locatoins for Unix and Mac OS X
  set(DEFAULT_BIN_SUBDIR bin)
  set(DEFAULT_LIB_SUBDIR lib)
  set(DEFAULT_DATA_SUBDIR share/liblas)
  set(DEFAULT_INCLUDE_SUBDIR include)
endif()

# Locations are changeable by user to customize layout of libLAS installation
# (default values are platform-specific)
set(LIBLAS_BIN_SUBDIR ${DEFAULT_BIN_SUBDIR} CACHE STRING
  "Subdirectory where executables will be installed")
set(LIBLAS_LIB_SUBDIR ${DEFAULT_LIB_SUBDIR} CACHE STRING
  "Subdirectory where libraries will be installed")
set(LIBLAS_INCLUDE_SUBDIR ${DEFAULT_INCLUDE_SUBDIR} CACHE STRING
  "Subdirectory where header files will be installed")
set(LIBLAS_DATA_SUBDIR ${DEFAULT_DATA_SUBDIR} CACHE STRING
  "Subdirectory where data will be installed")

# Mark *_SUBDIR variables as advanced and dedicated to use by power-users only.
mark_as_advanced(LIBLAS_BIN_SUBDIR
  LIBLAS_LIB_SUBDIR LIBLAS_INCLUDE_SUBDIR LIBLAS_DATA_SUBDIR)

# Full paths for the installation
set(LIBLAS_BIN_DIR ${LIBLAS_BIN_SUBDIR})
set(LIBLAS_LIB_DIR ${LIBLAS_LIB_SUBDIR})
set(LIBLAS_INCLUDE_DIR ${LIBLAS_INCLUDE_SUBDIR})
set(LIBLAS_DATA_DIR ${LIBLAS_DATA_SUBDIR})

###############################################################################
# Installation commands

install(FILES AUTHORS COPYING INSTALL LICENSE.txt README.txt
  DESTINATION ${LIBLAS_DATA_DIR}/doc)

###############################################################################
# Processing of project directories

add_subdirectory(src)

if(WITH_UTILITIES)
  message(STATUS "Enable libLAS utilities to build - done")
  add_subdirectory(apps)
endif()

if(WITH_TESTS)
  message(STATUS "Enable libLAS unit tests to build - done")
  enable_testing()

  add_subdirectory(test)
endif()

# Add find_package(libLAS) support
add_subdirectory(cmake)

# Version information
SET(CPACK_PACKAGE_VERSION_MAJOR ${LIBLAS_VERSION_MAJOR})
SET(CPACK_PACKAGE_VERSION_MINOR ${LIBLAS_VERSION_MINOR})
SET(CPACK_PACKAGE_VERSION_PATCH ${LIBLAS_VERSION_MINOR})

SET(CPACK_SOURCE_GENERATOR "TBZ2")
SET(CPACK_CMAKE_GENERATOR "Unix Makefiles")



set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${VERSION}")

list(APPEND CPACK_SOURCE_IGNORE_FILES "/test/data/TO_core_last_zoom.las")
list(APPEND CPACK_SOURCE_IGNORE_FILES "_CPack_Packages")
list(APPEND CPACK_SOURCE_IGNORE_FILES ".gz")
list(APPEND CPACK_SOURCE_IGNORE_FILES ".bz2")
list(APPEND CPACK_SOURCE_IGNORE_FILES ".git")
list(APPEND CPACK_SOURCE_IGNORE_FILES "README")
list(APPEND CPACK_SOURCE_IGNORE_FILES "HOWTORELEASE.txt")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/doc/_static/files")

list(APPEND CPACK_SOURCE_IGNORE_FILES "CMakeCache.txt")
list(APPEND CPACK_SOURCE_IGNORE_FILES "CMakeFiles")

=== apps/CMakeLists.txt ===
###############################################################################
#
# apps/CMakeLists.txt controls building of libLAS utilities
#
# Copyright (c) 2009 Mateusz Loskot <mateusz@loskot.net>
#
###############################################################################

include_directories(
    .
    ../include
    ../include/liblas/capi)

###############################################################################
# Collect programs to build

set(LASINFO lasinfo)
set(LAS2LAS las2las)
set(LAS2TXT las2txt)
set(TXT2LAS txt2las)
set(TS2LAS ts2las)
set(LASBLOCK lasblock )

if (NOT WIN32)
    set(LAS2COL las2col )
    set(LAS2PG las2pg )
endif()

set(BIGFILE_TEST bigfile_test)
set(LASINDEX_TEST lasindex_test)

if(Boost_IOSTREAMS_FOUND)
  set(BIGFILE_BIO_TEST bigfile_boost_iostreams_test)
endif()

# Set the build type to release if it is not explicitly set by the user and
# isn't in the cache yet
if (NOT CMAKE_BUILD_TYPE )
  set(CMAKE_BUILD_TYPE "Release")
endif()

# Utilities depending on 3rd-pary libraries
if(GDAL_FOUND)
    set(LAS2OGR las2ogr)
endif()


set(LIBLAS_UTILITIES
    ${LASINFO} ${LAS2LAS} ${TXT2LAS}  ${LAS2COL}  ${LAS2PG}
    ${LAS2OGR} ${LAS2LAS} ${LASBLOCK} ${TS2LAS}  ${LAS2TXT})

# TODO: Experimental and requires testing --mloskot
# Generate user-specific settings for Visual Studio project
set(VCPROJ_USER_REMOTE_MACHINE_DEBUG ${MACHINE_NAME})
set(VCPROJ_USER_ENVIRONMENT_DEBUG "${ENVIRONMENT_PATH}")

if(MSVC)
    foreach(utility ${LIBLAS_UTILITIES})
        set(USER_FILE ${utility}.vcproj.$ENV{USERDOMAIN}.$ENV{USERNAME}.user)
        set(OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR}/${USER_FILE})
        message(STATUS "Generating ${CMAKE_GENERATOR} user-specific settings in ${USER_FILE}")
        configure_file(${CMAKE_SOURCE_DIR}/cmake/libLAS.vcproj.user.template ${OUTPUT_PATH} @ONLY)
    endforeach()
endif()

###############################################################################
# Configure build targets

if(WIN32)
    add_definitions("-DLAS_DLL_EXPORT=1")
endif()


set(APPS_CPP_DEPENDENCIES
    ${LIBLAS_LIB_NAME}
)

# link_directories(${Boost_LIBRARY_DIRS})

#    add_executable(lasschematest lasschematest.cpp laskernel.cpp)
#    target_link_libraries(lasschematest ${APPS_CPP_DEPENDENCIES} ${LIBXML2_LIBRARIES})


if(LAS2LAS)
    add_executable(${LAS2LAS} las2las.cpp laskernel.cpp)
    target_link_libraries(${LAS2LAS} ${APPS_CPP_DEPENDENCIES} )
endif()

if(LASINFO)
    add_executable(${LASINFO} lasinfo.cpp laskernel.cpp )
    target_link_libraries(${LASINFO} ${APPS_CPP_DEPENDENCIES}  )
endif()

if(LAS2TXT)
    add_executable( ${LAS2TXT}  las2txt.cpp laskernel.cpp )
    target_link_libraries(${LAS2TXT} ${APPS_CPP_DEPENDENCIES}  )
endif()

# Build txt2las
if(TXT2LAS)
    set(TXT2LAS_SRC lascommon.c ${TXT2LAS}.c)
    add_executable(${TXT2LAS} ${TXT2LAS_SRC})
    target_link_libraries(${TXT2LAS} ${LIBLAS_C_LIB_NAME})
endif()

# Build las2col
if(LAS2COL)
    set(LAS2COL_SRC lascommon.c ${LAS2COL}.c)
    add_executable(${LAS2COL} ${LAS2COL_SRC})
    target_link_libraries(${LAS2COL} ${LIBLAS_C_LIB_NAME})
endif()

# Build las2pg
if(LAS2PG)
    set(LAS2PG_SRC lascommon.c ${LAS2PG}.c)
    add_executable(${LAS2PG} ${LAS2PG_SRC})
    target_link_libraries(${LAS2PG} ${LIBLAS_C_LIB_NAME})
endif()

if(TS2LAS)
    add_executable(${TS2LAS} ts2las.cpp laskernel.cpp)
    target_link_libraries(${TS2LAS} ${APPS_CPP_DEPENDENCIES} )
endif()

# Build lasblock
if(LASBLOCK)
    set(LASBLOCK_SRC lasblock.cpp laskernel.cpp)
    add_executable(${LASBLOCK} ${LASBLOCK_SRC})
    target_link_libraries(${LASBLOCK} ${APPS_CPP_DEPENDENCIES} )
endif()

# Build las2ogr
if(LAS2OGR)
    add_executable(${LAS2OGR} las2ogr.cpp)
    target_link_libraries(${LAS2OGR} ${APPS_CPP_DEPENDENCIES})
endif()


if(BIGFILE_TEST)
    add_executable(${BIGFILE_TEST} bigtest.c)
    target_link_libraries(${BIGFILE_TEST} ${LIBLAS_C_LIB_NAME})
endif()

if (LASINDEX_TEST)
    add_executable(${LASINDEX_TEST} lasindex_test.cpp)
    target_link_libraries(${LASINDEX_TEST} ${APPS_CPP_DEPENDENCIES})
endif()

if(BIGFILE_BIO_TEST)
    add_executable(${BIGFILE_BIO_TEST} bigfile_boost_iostreams_test.cpp)
    target_link_libraries(${BIGFILE_BIO_TEST} ${APPS_CPP_DEPENDENCIES} )
endif()

###############################################################################
# Targets installation

install(TARGETS ${LIBLAS_UTILITIES}
    RUNTIME DESTINATION ${LIBLAS_BIN_DIR}
    LIBRARY DESTINATION ${LIBLAS_LIB_DIR}
    ARCHIVE DESTINATION ${LIBLAS_LIB_DIR})


if(UNIX)

  set(LIBLAS_UTILS_RPATH ${CMAKE_INSTALL_PREFIX}/lib ${Boost_LIBRARY_DIRS})
  if(LASZIP_FOUND)
    get_filename_component(LASZIP_LIBRARY_DIRS ${LASZIP_LIBRARY} PATH)
    set (LIBLAS_UTILS_RPATH ${LIBLAS_UTILS_RPATH} ${LASZIP_LIBRARY_DIRS})
  endif()
  if(GEOTIFF_FOUND)
    get_filename_component(GEOTIFF_LIBRARY_DIRS ${GEOTIFF_LIBRARY} PATH)
    set (LIBLAS_UTILS_RPATH ${LIBLAS_UTILS_RPATH} ${GEOTIFF_LIBRARY_DIRS})
  endif()
  if(GDAL_FOUND)
    get_filename_component(GDAL_LIBRARY_DIRS ${GDAL_LIBRARY} PATH)
    set (LIBLAS_UTILS_RPATH ${LIBLAS_UTILS_RPATH} ${GDAL_LIBRARY_DIRS})
  endif()
  set_target_properties(${LIBLAS_UTILITIES} PROPERTIES
    INSTALL_RPATH "${LIBLAS_UTILS_RPATH}")

  if(WITH_PKGCONFIG)

    set(PKGCFG_PREFIX "${CMAKE_INSTALL_PREFIX}")
    set(PKGCFG_INC_DIR "${LIBLAS_INCLUDE_SUBDIR}")
    set(PKGCFG_LIB_DIR "${LIBLAS_LIB_SUBDIR}")
    set(PKGCFG_REQUIRES  "")
    set(PKGCFG_VERSION ${VERSION})
    set(PKGCFG_LINK_FLAGS "-llas -llas_c")
    set(PKGCFG_COMPILE_FLAGS "")
    if(LIBXML2_FOUND)
      set(PKGCFG_REQUIRES "${PKGCFG_REQUIRES} libxml-2.0")
    endif()
    if(GEOTIFF_FOUND)
      set(PKGCFG_REQUIRES "${PKGCFG_REQUIRES} geotiff")
    endif()
    #  if(WITH_GDAL)
    #    set(PKGCFG_INC_DIR "${PKGCFG_INC_DIR} ${GDAL_INCLUDE_DIR}")
    #  endif()
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/liblas.pc.in
      ${CMAKE_CURRENT_BINARY_DIR}/liblas.pc @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/liblas.pc
      DESTINATION ${LIBLAS_LIB_DIR}/pkgconfig
      PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

  else()

    # Autoconf compatibility variables to use the same script source.
    set(prefix ${CMAKE_INSTALL_PREFIX})
    set(exec_prefix ${CMAKE_INSTALL_PREFIX}/bin)
    set(libdir ${CMAKE_INSTALL_PREFIX}/lib)

    GET_DIRECTORY_PROPERTY(LIBLAS_DEFINITIONS DIRECTORY ${libLAS_SOURCE_DIR}/ COMPILE_DEFINITIONS)

    set(LIBLAS_CONFIG_DEFINITIONS "")
    foreach(definition ${LIBLAS_DEFINITIONS})
        set(LIBLAS_CONFIG_DEFINITIONS "${LIBLAS_CONFIG_DEFINITIONS} -D${definition}")
    endforeach()


    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/liblas-config.in
      ${CMAKE_CURRENT_BINARY_DIR}/liblas-config @ONLY)

    install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/liblas-config
      DESTINATION bin)

  endif()

endif()

=== cmake/CMakeLists.txt ===
#############################################################################
# Config file generation and installation
#############################################################################

# Set where cmake will install liblas-config.cmake.  It's installed in
# ${CMAKE_INSTALL_PREFIX}/${INSTALL_CMAKE_DIR} and ${PROJECT_ROOT_DIR}
# is the relative path to the root from there.
if (NOT WIN32)
  set(INSTALL_CMAKE_DIR "share/cmake/${PROJECT_NAME}")
  set (PROJECT_ROOT_DIR "../../..")
else ()
  set(INSTALL_CMAKE_DIR "cmake")
  set (PROJECT_ROOT_DIR "..")
endif ()

# Now create the liblas-config files using the .in templates
configure_file (liblas-config.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/liblas-config.cmake @ONLY)
configure_file (liblas-config-version.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/liblas-config-version.cmake @ONLY)

# Install the liblas-config files so that other modules can find this
# project using 'find_package(libLAS)'
install (FILES
  "${CMAKE_CURRENT_BINARY_DIR}/liblas-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/liblas-config-version.cmake"
  DESTINATION "${INSTALL_CMAKE_DIR}")

# Make information about libLAS available.  The depends target is
# defined in ../src/CMakeLists.txt
install (EXPORT depends
  FILE "liblas-depends.cmake"
  DESTINATION "${INSTALL_CMAKE_DIR}")

=== test/sample/CMakeLists.txt ===
# $Id$
#
# Build sample programs
#
SET( SAMPLE_READ sample_read )
SET( SAMPLE_WRITE sample_write )
SET( SAMPLE_FILES sample_files )

INCLUDE_DIRECTORIES(
    ../../include
)

ADD_EXECUTABLE( ${SAMPLE_READ} read.cpp )
ADD_EXECUTABLE( ${SAMPLE_WRITE} write.cpp )
ADD_EXECUTABLE( ${SAMPLE_FILES} files.cpp )

TARGET_LINK_LIBRARIES( ${SAMPLE_READ} ${LIBLAS_LIB_NAME} )
TARGET_LINK_LIBRARIES( ${SAMPLE_WRITE} ${LIBLAS_LIB_NAME} )
TARGET_LINK_LIBRARIES( ${SAMPLE_FILES} ${LIBLAS_LIB_NAME} )

=== test/unit/CMakeLists.txt ===
###############################################################################
#
# test/unit/CMakeLists.txt controls building of libLAS unit tests suite
#
# Copyright (c) 2009 Mateusz Loskot <mateusz@loskot.net>
#
###############################################################################
SET(LIBLAS_UNIT_TEST liblas_test)

SET(LIBLAS_UNIT_TEST_SRC
    bounds_test.cpp
    common.cpp
    error_test.cpp
    header_test.cpp
    point_test.cpp
    reader_iterator_test.cpp
    reader_test.cpp
    spatialreference_test.cpp
    transform_test.cpp
    variablerecord_test.cpp
    writer_test.cpp
    zipreader_test.cpp
    zipwriter_test.cpp
    liblas_test_suite.cpp)

INCLUDE_DIRECTORIES(
    .
    ../../include
    ${GDAL_INCLUDE_DIR}
    ${GEOTIFF_INCLUDE_DIR})

ADD_EXECUTABLE(${LIBLAS_UNIT_TEST} ${LIBLAS_UNIT_TEST_SRC} )

set_target_properties(${LIBLAS_UNIT_TEST} PROPERTIES COMPILE_DEFINITIONS LAS_DLL_IMPORT)

TARGET_LINK_LIBRARIES(${LIBLAS_UNIT_TEST} 
    ${LIBLAS_LIB_NAME}
    ${ZLIB_LIBRARIES}
    ${TIFF_LIBRARY}
    ${GEOTIFF_LIBRARY}
    ${GDAL_LIBRARY}
    ${SPATIALINDEX_LIBRARY})

ADD_TEST(liblas_test ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/liblas_test ${CMAKE_SOURCE_DIR}/test/data)

=== debian/changelog ===
liblas (1.8.1-6build1) bionic; urgency=medium

  * Rebuild against new gdal-abi-2-2-3.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 17 Dec 2017 22:10:37 +0100

liblas (1.8.1-6) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 17 Dec 2017 12:36:23 +0100

liblas (1.8.1-6~exp1) experimental; urgency=medium

  * Strip trailing whitespace from changelog.
  * Require at least libgdal-dev 2.2.3 for experimental builds.
  * Add lintian override for debian-watch-uses-insecure-uri.
  * Add lintian override for python-foo-but-no-python3-foo.
  * Bump Standards-Versiont to 4.1.2, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 14 Dec 2017 22:33:13 +0100

liblas (1.8.1-5) unstable; urgency=medium

  * Bump Standards-Versiont to 4.1.1, no changes.
  * Require at least libgdal-dev 2.2.2 for GDAL transition.
  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 03 Oct 2017 20:00:55 +0200

liblas (1.8.1-5~exp1) experimental; urgency=medium

  * Require at least libgdal-dev 2.2.2~ for experimental builds.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 16 Sep 2017 12:22:00 +0200

liblas (1.8.1-4) unstable; urgency=medium

  * Update symbols for mipsel & mips64el.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 10 Jul 2017 18:28:05 +0200

liblas (1.8.1-4~exp5) experimental; urgency=medium

  * Update symbols for x32.
  * Require at least libgdal-dev 2.2.1 for experimental builds.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 30 Jun 2017 14:48:48 +0200

liblas (1.8.1-4~exp4) experimental; urgency=medium

  * Fix SOURCE_DATE_EPOCH use.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 26 Jun 2017 20:13:58 +0200

liblas (1.8.1-4~exp3) experimental; urgency=medium

  * Require at least libgdal-dev 2.2.1~ for experimental builds.
  * Add autopkgtest to test installability.
  * Bump Standards-Versiont to 4.0.0, no changes.
  * Use pkg-info.mk variables instead of dpkg-parsechangelog output.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 23 Jun 2017 17:10:43 +0200

liblas (1.8.1-4~exp2) experimental; urgency=medium

  * Require at least libgdal-dev 2.2.0~ for experimental builds.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 15 Apr 2017 11:59:04 +0200

liblas (1.8.1-4~exp1) experimental; urgency=medium

  * Require at least libgdal-dev 2.1.3~ for experimental builds.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 20 Jan 2017 11:30:11 +0100

liblas (1.8.1-3) unstable; urgency=medium

  * Update symbols for other architectures.
  * Require at least libgdal-dev 2.1.2 for GDAL transition.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 28 Oct 2016 00:04:41 +0200

liblas (1.8.1-3~exp1) experimental; urgency=medium

  * Require at least libgdal-dev 2.1.2~ for experimental builds.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 14 Oct 2016 19:09:36 +0200

liblas (1.8.1-2) unstable; urgency=medium

  * Update symbols for other architectures.
  * Strip pre-release from symbols version.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 24 Aug 2016 17:53:49 +0200

liblas (1.8.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches, applied upstream.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 23 Aug 2016 22:11:28 +0200

liblas (1.8.1~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update watch file to force lowercase RC.
  * Drop patches, applied upstream.
  * Update copyright file, changes:
    - Add license & copyright for las2col.c & las2pg.c
    - Rename MIT license shortname to Expat
  * Add patch to fix 'offset' typo.
  * Update symbols for amd64.
  * Install las2col & las2pg in liblas-bin.
  * Add patch to fix spelling errors.
  * Add patch to support GNU/kFreeBSD in las2col & las2pg.
  * Add patch to support GNU/Hurd in las2col & las2pg.
  * Fix tests using LD_PRELOAD of liblas.so.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 22 Aug 2016 22:32:12 +0200

liblas (1.8.0-12) unstable; urgency=medium

  * Add patch to fix FTBFS with libgeotiff 1.4.2.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 11 Aug 2016 22:07:36 +0200

liblas (1.8.0-11) unstable; urgency=medium

  * Require at least libgdal-dev 2.1.1 for GDAL transition.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 13 Jul 2016 16:34:41 +0200

liblas (1.8.0-11~exp1) experimental; urgency=medium

  * Require at least libgdal-dev 2.1.1~ for experimental builds.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 04 Jul 2016 11:29:08 +0200

liblas (1.8.0-10) unstable; urgency=medium

  * Move from experimental to unstable.
  * Update symbols for hppa.
  * Drop unused override for old-style-config-script-multiarch-path.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 10 May 2016 15:40:29 +0200

liblas (1.8.0-10~exp1) experimental; urgency=medium

  * Require at least libgdal-dev 2.1 for experimental builds.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 02 May 2016 20:16:50 +0200

liblas (1.8.0-9) unstable; urgency=medium

  * Bump Standards-Version to 3.9.8, no changes.
  * Enable all hardening buildflags.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 17 Apr 2016 16:39:13 +0200

liblas (1.8.0-8) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 01 Mar 2016 23:19:16 +0100

liblas (1.8.0-8~exp1) experimental; urgency=medium

  * Update Vcs-Git URL to use HTTPS.
  * Add patches for various typos.
  * Add lintian override for old-style-config-script-multiarch-path.
    See: https://lists.debian.org/debian-devel/2016/01/msg00688.html
  * Bump Standards-Version to 3.9.7, no changes.


=== debian/control ===
Source: liblas
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           David Paleino <dapal@debian.org>,
           Bas Couwenberg <sebastic@debian.org>,
           Ross Gammon <rossgammon@mail.dk>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               pkg-kde-tools,
               cmake,
               chrpath,
               libgeotiff-dev,
               libgdal-dev (>= 2.2.3),
               libtiff-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-thread-dev,
               python-all-dev,
               python-setuptools,
               dh-python,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               xsltproc
Standards-Version: 4.1.2
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/liblas.git
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/liblas.git
Homepage: http://liblas.org/
X-Python-Version: >= 2.5

Package: liblas3
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: libgeotiff-epsg
Description: ASPRS LiDAR data translation library - C++ version
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains the C++ shared library used by applications.

Package: liblas-c3
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         liblas3 (= ${binary:Version})
Suggests: libgeotiff-epsg
Description: ASPRS LiDAR data translation library - C version
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains the C shared library used by applications.

Package: liblas-dev
Architecture: any
Section: libdevel
Depends: liblas3 (= ${binary:Version}),
         libgeotiff-dev,
         libgdal-dev (>= 1.10.0~),
         libtiff-dev,
         libboost-dev,
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-program-options-dev,
         libboost-thread-dev,
         ${misc:Depends}
Description: ASPRS LiDAR data translation library - C++ development files
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains the development files to build applications in C++.

Package: liblas-c-dev
Architecture: any
Section: libdevel
Depends: liblas-c3 (= ${binary:Version}),
         liblas-dev (= ${binary:Version}),
         libgeotiff-dev,
         libgdal-dev (>= 1.10.0~),
         ${misc:Depends}
Description: ASPRS LiDAR data translation library - C development files
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains the development files to build applications in C.

Package: liblas-bin
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: libgeotiff-epsg
Description: ASPRS LiDAR data translation toolset
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains the essential toolset to manage LiDAR data:
 lasinfo, lasmerge, las2las, las2txt, txt2las, las2ogr.

Package: python-liblas
Architecture: all
Section: python
Depends: liblas-c3,
         ${python:Depends},
         ${misc:Depends}
Description: Python module to use the ASPRS LiDAR data translation library
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains a Python module to use libLAS.

=== debian/rules ===
#!/usr/bin/make -f

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/pkg-info.mk

UPSTREAM_VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

BUILD_DATE=$(shell LC_ALL=C date -u "+%d %B %Y" -d "@$(SOURCE_DATE_EPOCH)")

MANPAGES:=$(wildcard debian/man/*.*.xml)

%:
	dh $@ --buildsystem cmake \
	      --with python2,pkgkde_symbolshelper \
	      --parallel

override_dh_auto_clean-indep:
	dh_auto_clean --sourcedirectory python --buildsystem pybuild

override_dh_clean:
	dh_clean README.txt debian/man/*.1

override_dh_auto_configure:
	dh_auto_configure --builddirectory=debian/build -- \
		-DCMAKE_VERBOSE_MAKEFILE=1 \
		-DWITH_GDAL=TRUE \
		-DWITH_GEOTIFF=TRUE \
		-DGEOTIFF_INCLUDE_DIR=/usr/include/geotiff

override_dh_auto_configure-indep:
	dh_auto_configure --sourcedirectory python --buildsystem pybuild

override_dh_auto_build-arch:
	# Create man pages from DocBook XML
	for x in $(MANPAGES) ; do \
	  docbook2x-man --string-param header-3="$(BUILD_DATE)" $$x ; \
	  mv `basename $$x | sed 's/.xml$$//'` `dirname $$x` ; \
	done

	dh_auto_build --builddirectory=debian/build

override_dh_auto_build-indep:
	dh_auto_build --sourcedirectory python --buildsystem pybuild

override_dh_auto_test:
	LD_PRELOAD="$(CURDIR)/debian/build/bin/None/liblas.so.3" dh_auto_test --builddirectory=debian/build || echo "Ignoring test failures"

override_dh_auto_install-arch:
	dh_auto_install --builddirectory=debian/build

override_dh_auto_install-indep:
	chmod -x python/examples/* python/scripts/*
	dh_auto_install --sourcedirectory python --buildsystem pybuild

override_dh_install-arch:
	$(RM) debian/*/usr/share/liblas/doc/AUTHORS
	$(RM) debian/*/usr/share/liblas/doc/COPYING
	$(RM) debian/*/usr/share/liblas/doc/INSTALL
	$(RM) debian/*/usr/share/liblas/doc/README.txt
	$(RM) debian/*/usr/share/liblas/doc/LICENSE.txt

	dh_install --arch --list-missing

	# remove capi from liblas-dev
	rm -vrf debian/liblas-dev/usr/include/liblas/capi/

	# removing embedded rpath in binaries
	-find debian/liblas-bin/usr/bin -type f -exec chrpath --delete {} \;

override_dh_install-indep:
	dh_install --indep --list-missing

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(UPSTREAM_VERSION)

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|b|beta|alpha)\d*)$/$1~$2/;s/RC/rc/ \
http://download.osgeo.org/liblas/ \
(?:.*?/)?(?:libLAS)?[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
